package application;

import graphic2D.Triangle;
import gui.GUI;

import java.awt.Image;
import java.awt.geom.Point2D;
import java.util.Vector;

public abstract class App{
	public final static int APP_RET_OK = 0;
	public final static int APP_RET_ABORT = -1;
	
	protected GUI gui;

	public abstract void setGui(GUI gui);
	public abstract GUI getGui();
	
	public abstract boolean openLeftImage(String filename);

	public abstract boolean openRightImage(String filename);
	
	//public abstract boolean saveLeftImage(String filename);

	//public abstract boolean saveRightImage(String filename);
	public abstract void execute(Vector<Point2D> srcPoints, Vector<Triangle> srcTriangles, Image srcImg, Vector<Point2D> dstPoints, Vector<Triangle> dstTriangles, Image dstImg);

	public abstract int exit();
	public abstract boolean openProject(String filename);
	public abstract boolean saveProject(String filename);
	
}
