package extern;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;

import javax.swing.JFrame;

/**
* Eine Klasse, die nur ein BufferedImage zeichnet. Sie kann zum
* Double-Buffering verwendet werden.
*
* @author Frank Klawonn
* Letzte Aenderung 27.05.2005@SuppressWarnings("serial")

*/
public class BufferedImageDrawer extends JFrame
{
  /**
	 * 
	 */
	private static final long serialVersionUID = -8473308652825170391L;

//Dieses Bild wird beim Aufruf der paint-Methode gezeichnet.
  public BufferedImage bi;

  //Mit diesem Objekt kann auf bi gezeichnet werden.
  public Graphics2D g2dbi;

  //Das Graphics2D-Objekt, das in der paint-Methode verwendet wird.
  private Graphics2D g2d;

  /**
  * Konstruktor
  */
  public BufferedImageDrawer(BufferedImage buffIm, int width, int height)
  {
    bi = buffIm;
    g2dbi = bi.createGraphics();

    //Ermoeglicht das Schliessen des Fensters
    addWindowListener(new MyFinishWindow());

    this.setTitle("Double-Buffering");
    this.setSize(width,height+20);
    this.setVisible(true);

  }


  public void paint(Graphics g)
  {
    update(g);
  }


  public void update(Graphics g)
  {
    g2d = (Graphics2D) g;
    g2d.drawImage(bi,0,20,null);
  }


}


