package gui.listener;

import graphic2D.Triangle;
import gui.GUI;
import gui.ImagePanel;

import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionAdapter;
import java.awt.geom.AffineTransform;
import java.awt.geom.Point2D;
import java.util.Vector;

import application.App;

public class AppMouseMotionAdapter extends MouseMotionAdapter implements
		MouseListener, Runnable {

	App app;

	GUI gui;

	public AppMouseMotionAdapter(App app) {
		super();
		this.app = app;
		this.gui = app.getGui();
		trianglePoints = new Vector<Point2D>();
	}

	Point2D p2d_draged;

	// Point2D p2d_draged_init;

	Vector<Point2D> trianglePoints;

	// int currentConer = -1;

	boolean checkingSingleClick = false;

	MouseEvent me;

	private boolean mayMove(Point2D current_p, Point2D new_p, ImagePanel pi) {
		return (pi.getImage() != null) && (current_p != null)
				&& (new_p != null) && (new_p.getX() >= 0)
				&& (new_p.getY() >= 0)
				&& (new_p.getX() < pi.getImage().getWidth(null))
				&& (new_p.getY() < pi.getImage().getHeight(null))
				&& !pi.intersectsAnEdge(current_p, new_p, pi.getAllEdges());
	}

	@Override
	public void mouseDragged(MouseEvent arg0) {
		if (arg0.getSource() instanceof ImagePanel) {
			ImagePanel ip = (ImagePanel) arg0.getSource();
			Point2D new_p = new Point2D.Double(arg0.getX(), arg0.getY());
			AffineTransform inverseScale = ip.getInverseScaleTransform();
			if (inverseScale != null) {
				new_p = inverseScale.transform(new_p, null);
				if (mayMove(p2d_draged, new_p, ip)) {
					if (p2d_draged != null) {
						ip.moveToPoint(p2d_draged, new_p);
						gui.invalidate();
						gui.validate();
					}
				}
			}
		}
	}

	public synchronized boolean checkSingleClick(boolean started) {
		boolean old_val = checkingSingleClick;
		checkingSingleClick = started;
		return old_val;
	}

	public void mouseClicked(MouseEvent arg0) {
		switch (arg0.getClickCount()) {
		case 1:
			checkSingleClick(true);
			this.me = arg0;
			Thread t = new Thread(this);
			t.start();
			break;
		case 2:
			checkSingleClick(false);
			break;
		}

		if ((arg0.getButton() == MouseEvent.BUTTON1)
				&& (arg0.getClickCount() == 2)) {
			// double click
			if (!app.getGui().isTriangleMode()) {// PointMode
				if (arg0.getSource() instanceof ImagePanel) {
					ImagePanel ip = (ImagePanel) arg0.getSource();
					if (ip == gui.getLeftImagePanel()) {
						Point2D new_p = new Point2D.Double(arg0.getX(), arg0
								.getY());

						AffineTransform inverseScale = ip
								.getInverseScaleTransform();
						if (inverseScale != null) {
							new_p = inverseScale.transform(new_p, null);
							if (!ip.isPointSet(new_p)) {
								ip.addPoint(new_p);
							}
						}
					}
				}
			}
		} else if ((arg0.getButton() == MouseEvent.BUTTON3)
				&& (arg0.getClickCount() == 2)) {
			System.out.println("yeah!!");

		}
	}

	public void mousePressed(MouseEvent arg0) {
		Point2D new_p = new Point2D.Double(arg0.getX(), arg0.getY());

		if (arg0.getSource() instanceof ImagePanel) {
			ImagePanel ip = (ImagePanel) arg0.getSource();
			AffineTransform inverseScale = ip.getInverseScaleTransform();
			if (inverseScale != null) {
				new_p = inverseScale.transform(new_p, null);
				if (ip.isPointSet(new_p)) {
					p2d_draged = ip.getNearstPointTo(new_p);
				} else {
					Vector<Triangle> src_t;
					ImagePanel srcPanel;
					ImagePanel dstPanel;
					if (ip == app.getGui().getLeftImagePanel()) {
						srcPanel = app.getGui().getLeftImagePanel();
						dstPanel = app.getGui().getRightImagePanel();
						src_t = app.getGui().getLeftImagePanel().getTriangles();
					} else {
						srcPanel = app.getGui().getRightImagePanel();
						dstPanel = app.getGui().getLeftImagePanel();
						src_t = app.getGui().getRightImagePanel()
								.getTriangles();
					}
					boolean found=false;
					for(int i=0;!found&&i<src_t.size();i++){
						if(src_t.get(i).isPointIn(new_p)){
							srcPanel.flashTriangle(i,true);
							dstPanel.flashTriangle(i,true);
							gui.getLeftImagePanel().repaint();
							gui.getRightImagePanel().repaint();
							found = true;
						}
					}
				}
			}
		}
	}

	public void mouseReleased(MouseEvent arg0) {
		p2d_draged = null;
		gui.getLeftImagePanel().flashTriangle(-1,false);
		gui.getRightImagePanel().flashTriangle(-1,false);
		gui.getLeftImagePanel().repaint();
		gui.getRightImagePanel().repaint();
		
	}

	public void mouseEntered(MouseEvent arg0) {
		// TODO Auto-generated method stub

	}

	public void mouseExited(MouseEvent arg0) {
		// TODO Auto-generated method stub

	}

	public void run() {
		try {
			Thread.sleep(300);
		} catch (InterruptedException e) {
		}
		if (checkSingleClick(false)) {
			singleClick(me);
		}

	}

	private void singleClick(MouseEvent me) {
		if (me.getButton() == MouseEvent.BUTTON1) {
			// left button
			if (app.getGui().isTriangleMode()) {// TriangleMode
				if (me.getSource() instanceof ImagePanel) {
					ImagePanel ip = (ImagePanel) me.getSource();
					if (ip == gui.getLeftImagePanel()) {
						Point2D new_p = new Point2D.Double(me.getX(), me.getY());

						AffineTransform inverseScale = ip
								.getInverseScaleTransform();
						if (inverseScale != null) {
							new_p = inverseScale.transform(new_p, null);
							if (ip.isPointSet(new_p)) {
								System.out.println("point auswahl!");
								Point2D p = ip.getNearstPointTo(new_p);
								int i = 0;
								while ((i < trianglePoints.size())
										&& (!p.equals(trianglePoints.get(i))))
									i++;
								if (i == trianglePoints.size()) {
									System.out
											.println("new point in triangle!");
									trianglePoints.addElement(p);
									if (trianglePoints.size() == 3) {
										if (ip.addTriangleConer(p)) {
											System.out.println("cc=2");
											if (!ip.addTriangle(trianglePoints)) {
												System.out
														.println("falscher pkt");
												ip.removeTriangleConer(p);
												trianglePoints.removeElement(p);
											} else {
												System.out
														.println("triangle added!");
												gui
														.enableCommitBtn(ip
																.completeToCommit()
																&& gui
																		.getRightImagePanel()
																		.isImageLoaded());
												trianglePoints.clear();
											}
										} else {
											trianglePoints.removeElement(p);
										}
									} else {
										if (!ip.addTriangleConer(p)) {
											trianglePoints.removeElement(p);
										}
									}
								} else {
									ip.removeTriangleConer(p);
									trianglePoints.removeElement(p);
								}
							}
						}
					}
				}
			}
		}

	}

}
