package gui.listener;

import gui.GUI;

import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;

import javax.swing.WindowConstants;

import application.App;

public class AppWindowAdapter extends AppActionListener implements
		WindowListener {

	public AppWindowAdapter(App app) {
		super(app);
	}

	public void windowOpened(WindowEvent e) {
	}

	public void windowClosing(WindowEvent e) {
		int err = app.exit();
		switch (err) {
		case App.APP_RET_OK:
		case App.APP_RET_ABORT:
			System.exit(err);
			System.out.println("not app!");
			System.out.flush();
		default:
			if (e.getSource() instanceof GUI) {
				GUI gui = (GUI) e.getSource();
				gui.setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
				System.err.println("don't know what to do :-/");
				System.err.println("app is running...");
			}
		}
	}

	public void windowClosed(WindowEvent e) {
		System.err.println("");
	}

	public void windowIconified(WindowEvent e) {
	}

	public void windowDeiconified(WindowEvent e) {
	}

	public void windowActivated(WindowEvent e) {
	}

	public void windowDeactivated(WindowEvent e) {
	}

}
