package gui.listener;

import graphic2D.Triangle;
import gui.GUI;
import gui.MyButton;
import io.StreamStringConverter;
import io.XmlConverter;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.FileDialog;
import java.awt.GridLayout;
import java.awt.Image;
import java.awt.Rectangle;
import java.awt.SystemColor;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.geom.Point2D;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.List;
import java.util.Vector;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JMenuItem;
import javax.swing.JScrollPane;
import javax.swing.JTextPane;
import javax.swing.text.BadLocationException;
import javax.swing.text.SimpleAttributeSet;
import javax.swing.text.StyleConstants;
import javax.swing.text.StyledDocument;

import org.jdom.Attribute;
import org.jdom.Element;
import org.jdom.JDOMException;
import org.xml.sax.SAXException;

import application.App;

public class MenuFileActionListener extends AppActionListener implements
		ActionListener {

	Color farbe = null;

	JDialog dlghelp = null;
	JDialog dlgabout = null;

	public MenuFileActionListener(App app) {
		super(app);
	}

	private String getFileName(String title, int mode) {
		FileDialog fd = new FileDialog(this.app.getGui(), title, mode);
		fd.setVisible(true);
		String filename = fd.getDirectory() + fd.getFile();
		if (fd.getFile() == null)
			filename = null;
		return filename;
	}

	public void actionPerformed(ActionEvent e) {
		if ((e.getSource() instanceof JMenuItem)
				&& (((JMenuItem) e.getSource()).getText()
						.equals(GUI.MENU_FILE_EXIT))) {
			int err = app.exit();
			switch (err) {
			case App.APP_RET_OK:
			case App.APP_RET_ABORT:
				System.exit(err);
			default:
				System.err.println("don't know what to do :-/");
				System.err.println("app is running...");
			}
		} else if ((e.getSource() instanceof MyButton)
				&& ((((MyButton) e.getSource()).getText().equals("Triangle")) || ((MyButton) e
						.getSource()).getText().equals("Point"))) {
			MyButton b = (MyButton) e.getSource();
			Vector<JButton> v = b.getOthers();
			if (farbe == null)
				farbe = b.getBackground();
			for (int i = 0; i < v.size(); i++) {
				v.get(i).setEnabled(true);
				v.get(i).setBackground(farbe);
			}
			b.setEnabled(false);
			b.setBackground(Color.GREEN);
			app.getGui().toggleTriangleMode();
			System.out.println(app.getGui().isTriangleMode());
		} else if ((e.getSource() instanceof JButton)
				&& (((JButton) e.getSource()).getText()
						.equals("Dreiecke bernehmen"))) {
			Vector<Triangle> triangles = app.getGui().getLeftImagePanel()
					.getTriangles();
			Vector<Point2D> points = app.getGui().getLeftImagePanel()
					.getPoints();
			app.getGui().getRightImagePanel().setTriangles(points, triangles);
			app.getGui().enableExecuteBtn(true);

		} else if ((e.getSource() instanceof JButton)
				&& (((JButton) e.getSource()).getText().equals("DO IT!"))) {
			Vector<Triangle> ltriangles = app.getGui().getLeftImagePanel()
					.getTriangles();
			Vector<Point2D> lpoints = app.getGui().getLeftImagePanel()
					.getPoints();
			Vector<Triangle> rtriangles = app.getGui().getRightImagePanel()
					.getTriangles();
			Vector<Point2D> rpoints = app.getGui().getRightImagePanel()
					.getPoints();
			Image limg = app.getGui().getLeftImagePanel().getImage();
			Image rimg = app.getGui().getRightImagePanel().getImage();
			app.execute(lpoints, ltriangles, limg, rpoints, rtriangles, rimg);

		} else if (((e.getSource() instanceof JMenuItem) && (((JMenuItem) e
				.getSource()).getText().equals(GUI.MENU_FILE_OPEN_LEFT_IMAGE)))
				|| ((e.getSource() instanceof JButton) && (((JButton) e
						.getSource()).getIcon().toString()
						.equals(GUI.SC_OPEN_LEFT_IMAGE)))) {
			app.getGui().setStateText(" Loading...");
			String filename = getFileName(GUI.MENU_FILE_OPEN_LEFT_IMAGE,
					FileDialog.LOAD);
			if (filename != null) {
				if (app.openLeftImage(filename)) {
					app.getGui().setStateText(" Loaded");
				} else {
					app
							.getGui()
							.setStateText(
									" Error, not loaded! (does the file contain an image? evtl. check permissions!)");
				}
			} else {
				app.getGui().setStateText(" Loading aborted");
			}
		} else if (((e.getSource() instanceof JMenuItem) && (((JMenuItem) e
				.getSource()).getText().equals(GUI.MENU_FILE_OPEN_RIGHT_IMAGE)))
				|| ((e.getSource() instanceof JButton) && (((JButton) e
						.getSource()).getIcon().toString()
						.equals(GUI.SC_OPEN_RIGHT_IMAGE)))) {
			app.getGui().setStateText(" Loading...");
			String filename = getFileName(GUI.MENU_FILE_OPEN_RIGHT_IMAGE,
					FileDialog.LOAD);
			if (filename != null) {
				if (app.openRightImage(filename)) {
					app.getGui().setStateText(" Loaded");
				} else {
					app
							.getGui()
							.setStateText(
									" Error, not loaded! (does the file contain an image? evtl. check permissions!)");
				}
			} else {
				app.getGui().setStateText(" Loading aborted");
			}
		} else if (((e.getSource() instanceof JMenuItem) && (((JMenuItem) e
				.getSource()).getText().equals(GUI.MENU_FILE_OPEN_PROJECT)))
				|| ((e.getSource() instanceof JButton) && (((JButton) e
						.getSource()).getIcon().toString()
						.equals(GUI.SC_OPEN_PROJECT)))) {
			app.getGui().setStateText(" loading project...");
			String filename = getFileName(GUI.MENU_FILE_OPEN_PROJECT,
					FileDialog.LOAD);
			if (filename != null) {
				if (app.openProject(filename)) {
					app.getGui().setStateText(" Loaded");
				} else {
					app.getGui().setStateText(" Error, not loaded!");
				}
			} else {
				app.getGui().setStateText(" Loading aborted");
			}
		} else if (((e.getSource() instanceof JMenuItem) && (((JMenuItem) e
				.getSource()).getText().equals(GUI.MENU_HELP_HELP)))) {
			try {
				Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
				JTextPane textPane = new JTextPane();
				if (dlghelp == null) {
					String help = StreamStringConverter.convertFile(new File(
							"src/conf/help.xml"));
					Element elem = XmlConverter.getJDOMDocument(help)
							.getRootElement();
					String title = "help...";
					dlghelp = new JDialog(app.getGui(), title);
					JScrollPane sp = new JScrollPane(textPane);
					StyledDocument sdoc = textPane.getStyledDocument();
					SimpleAttributeSet attr = new SimpleAttributeSet();
					// sdoc.insertString(sdoc.getLength(),help,null);
					textPane.setEditable(false);
					drawHelp(sdoc, elem, attr);
					dlghelp.setSize((int) Math.round(d.getWidth() * 2 / 3), (int) Math.round(d
							.getHeight() * 2 / 3));
					dlghelp.setLocation((d.width - dlghelp.getSize().width) / 2 + 30, (d.height - dlghelp
							.getSize().height) / 2 + 30);
					GridLayout gb = new GridLayout(1, 1);
					dlghelp.setLayout(gb);
					dlghelp.getContentPane().add(sp);
					dlghelp.repaint();
				}
				dlghelp.setVisible(true);
				textPane.repaint();
				textPane.setAutoscrolls(true);
				textPane.scrollRectToVisible(new Rectangle(0,0,(int) Math.round(d.getWidth() * 2 / 3),(int) Math.round(d.getHeight() * 2 / 3)));
				textPane.setPreferredSize(new Dimension((int) Math.round(d.getWidth() * 2 / 3),(int) Math.round(d.getHeight() * 2 / 3)));
				
				textPane.revalidate();
				textPane.repaint();

			} catch (FileNotFoundException e1) {
				System.out.println("help file not found!");
			} catch (IOException e2) {
				e2.printStackTrace();
			} catch (BadLocationException e3) {
				e3.printStackTrace();
			} catch (SAXException e4) {
				e4.printStackTrace();
			} catch (JDOMException e5) {
				e5.printStackTrace();
			}

		} else if (((e.getSource() instanceof JMenuItem) && (((JMenuItem) e
				.getSource()).getText().equals(GUI.MENU_HELP_ABOUT)))) {
			try {
				if (dlgabout == null) {
					String help = StreamStringConverter.convertFile(new File(
							"src/conf/about.xml"));
					Element elem = XmlConverter.getJDOMDocument(help)
							.getRootElement();
					dlgabout = new JDialog(app.getGui(), "about...");
					Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
					JTextPane textPane = new JTextPane();
					textPane.setBackground(dlgabout.getBackground());
					JScrollPane sp = new JScrollPane(textPane);
					StyledDocument sdoc = textPane.getStyledDocument();
					SimpleAttributeSet attr = new SimpleAttributeSet();
					textPane.setEditable(false);
					drawHelp(sdoc, elem, attr);
					dlgabout.setSize(new Dimension(400, 200));
					dlgabout.setLocation((d.width - dlgabout.getSize().width) / 2,
							(d.height - dlgabout.getSize().height) / 2);
					GridLayout gb = new GridLayout(1, 1);
					dlgabout.setLayout(gb);
					dlgabout.getContentPane().add(sp);
				}
				dlgabout.setVisible(true);
			} catch (FileNotFoundException e1) {
				System.out.println("help file not found!");
			} catch (IOException e2) {
				e2.printStackTrace();
			} catch (BadLocationException e3) {
				e3.printStackTrace();
			} catch (SAXException e4) {
				e4.printStackTrace();
			} catch (JDOMException e5) {
				e5.printStackTrace();
			}

		} else if (((e.getSource() instanceof JMenuItem) && (((JMenuItem) e
				.getSource()).getText().equals(GUI.MENU_FILE_SAVE_PROJECT)))
				|| ((e.getSource() instanceof JButton) && (((JButton) e
						.getSource()).getIcon().toString()
						.equals(GUI.SC_SAVE_PROJECT)))) {
			app.getGui().setStateText(" saving project...");
			String filename = getFileName(GUI.MENU_FILE_SAVE_PROJECT,
					FileDialog.SAVE);
			if (filename != null) {
				if (app.saveProject(filename)) {
					app.getGui().setStateText(" Saved");
				} else {
					app.getGui().setStateText(" Error, not saved!");
				}
			} else {
				app.getGui().setStateText(" Saving aborted");
			}
		}
	}

	@SuppressWarnings("unchecked")
	private void drawHelp(StyledDocument sdoc, Element elem,
			SimpleAttributeSet attr) throws BadLocationException {
		SimpleAttributeSet current_attr = new SimpleAttributeSet();
		current_attr.addAttributes(attr);
		//sdoc.setParagraphAttributes(sdoc.getLength(),0,current_attr,true);
		List<Attribute> el_attrs = elem.getAttributes();
		for (int i = 0; i < el_attrs.size(); i++) {
			Attribute a = el_attrs.get(i);
			if (a.getName().equals("size")) {
				if (a.getValue().startsWith("+")) {
					StyleConstants
							.setFontSize(current_attr, StyleConstants
									.getFontSize(attr)
									+ new Integer(a.getValue().substring(1))
											.intValue());
				} else if (a.getValue().startsWith("-")) {
					StyleConstants
							.setFontSize(current_attr, StyleConstants
									.getFontSize(attr)
									- new Integer(a.getValue().substring(1))
											.intValue());
				} else {
					StyleConstants.setFontSize(current_attr, new Integer(a
							.getValue()).intValue());
				}
			} else if (a.getName().equals("color")) {
				// color="ff0000" <- steht fuer "rot"
				// color="00ff00" <- steht fuer "gruen"
				// und so weiter. Also eine RGB Farbe in HEX-Format.
				StyleConstants.setForeground(current_attr, new Color(Integer
						.valueOf(a.getValue(), 16).intValue()));
			} else if (a.getName().equals("background")) {
				// color="ff0000" <- steht fuer "rot"
				// color="00ff00" <- steht fuer "gruen"
				// und so weiter. Also eine RGB Farbe in HEX-Format.
				if (a.getValue().equals("system"))
					StyleConstants.setBackground(current_attr, SystemColor.window);
				else 
					StyleConstants.setBackground(current_attr, new Color(Integer
							.valueOf(a.getValue(), 16).intValue()));
			} else if (a.getName().equals("style")) {
				// style="italic" schaltet kursiv ein
				// style="+italic" schaltet ebenfalls kursiv ein
				// style="bold" fettschrift
				// style="+bold" ebenfalls fettschrift
				// style="underlined"
				// style="+underlined"
				// style="-underlined"
				//
				if (a.getValue().matches(".*italic.*")) {
					StyleConstants.setItalic(current_attr, !a.getValue()
							.matches(".*[-]italic.*"));
				}
				if (a.getValue().matches(".*bold.*")) {
					StyleConstants.setBold(current_attr, !a.getValue().matches(
							".*[-]bold.*"));
				}
				if (a.getValue().matches(".*underlined.*")) {
					StyleConstants.setUnderline(current_attr, !a.getValue()
							.matches(".*[-]underlined.*"));
				}
				if (a.getValue().matches(".*center.*")) {
					System.out.println("center");
					StyleConstants.setAlignment(current_attr, StyleConstants.ALIGN_CENTER);
				}
				if (a.getValue().matches(".*left.*")) {
					System.out.println("left");
					StyleConstants.setAlignment(current_attr, StyleConstants.ALIGN_LEFT);
				}
				if (a.getValue().matches(".*right.*")) {
					System.out.println("right");
					StyleConstants.setAlignment(current_attr, StyleConstants.ALIGN_RIGHT);
				}
			}
		}
		if (elem.getName().equals("text")){
			sdoc.setParagraphAttributes(sdoc.getLength(),0,current_attr,true);
			sdoc.insertString(sdoc.getLength(), elem.getTextNormalize(),
					current_attr);
		}
		else if (elem.getName().equals("br")){
			sdoc.insertString(sdoc.getLength(), "\n", current_attr);
		}
		List<Element> children = elem.getChildren();
		for (int i = 0; i < children.size(); i++) {
			drawHelp(sdoc, children.get(i), current_attr);
		}
	}
}
