package io;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.Reader;

public final class StreamStringConverter {

	public final static String convertStream(InputStream input_stream)
			throws IOException {
		StringBuffer content = new StringBuffer();
		BufferedReader buffer_reader = new BufferedReader(
				new InputStreamReader(input_stream));
		String line_separator = System.getProperty("line.separator");
		String next_line = new String();
		while ((next_line = buffer_reader.readLine()) != null) {
			content.append(next_line + line_separator);
		}
		return content.toString();
	}

	public final static String convertReader(Reader reader) throws IOException {
		StringBuffer content = new StringBuffer();
		BufferedReader buffer_reader = new BufferedReader(reader);
		String line_separator = System.getProperty("line.separator");
		String next_line = new String();
		while ((next_line = buffer_reader.readLine()) != null) {
			content.append(next_line + line_separator);
		}
		return content.toString();
	}

	public final static String convertFile(File f)
			throws FileNotFoundException, IOException {
		FileReader fr = new FileReader(f);
		return convertReader(fr);
	}
}