package io;

import java.io.File;
import java.io.IOException;
import java.io.StringReader;

import org.jdom.JDOMException;
import org.jdom.input.DOMBuilder;
import org.jdom.input.SAXBuilder;
import org.jdom.output.Format;
import org.jdom.output.XMLOutputter;
import org.xml.sax.SAXException;

public final class XmlConverter {

	private final static synchronized org.jdom.Document buildJDOMDocument(
			org.w3c.dom.Document dom_document) {
		DOMBuilder dom_builder = new DOMBuilder();
		org.jdom.Document doc = dom_builder.build(dom_document);
		return doc;
	}


	public final static synchronized org.jdom.Document getJDOMDocument(
			String xml_string) throws SAXException, IOException, JDOMException {
		SAXBuilder builder = new SAXBuilder();
		org.jdom.Document document = builder
				.build(new StringReader(xml_string));
		return document;
	}

	public final static synchronized org.jdom.Document getJDOMDocument(
			org.w3c.dom.Document dom_document) {
		return buildJDOMDocument(dom_document);
	}

	public final static synchronized org.jdom.Document getJDOMDocument(File f)
			throws JDOMException, IOException {
		return new SAXBuilder().build(f);
	}

	public final static synchronized String getXMLString(
			org.w3c.dom.Document dom_document) {
		org.jdom.Document doc = buildJDOMDocument(dom_document);
		XMLOutputter xml_outputter = new XMLOutputter();
		String xml_output = xml_outputter.outputString(doc);
		return xml_output;
	}

	public final static synchronized String getXMLString(
			org.jdom.Document jdom_document) {
		XMLOutputter xml_outputter = new XMLOutputter();
		Format frmt = Format.getPrettyFormat();
		xml_outputter.setFormat(frmt);
		String xml_output = xml_outputter.outputString(jdom_document);
		return xml_output;
	}

	public final static synchronized String convertXML(String xml_content)
			throws JDOMException, IOException {
		SAXBuilder sax_builder = new SAXBuilder();
		org.jdom.Document doc = sax_builder
				.build(new StringReader(xml_content));
		XMLOutputter xml_outputter = new XMLOutputter();
		Format frmt = Format.getPrettyFormat();
		xml_outputter.setFormat(frmt);
		String xml_output = xml_outputter.outputString(doc);
		return xml_output;
	}
}
